		; bic teil 2
		; org 2746h

;------------------------------------------------------------------------------
; VOCABULARY DOS
;------------------------------------------------------------------------------

		voc FORTH
		header VDOS, "DOS",DOVOC

		dw lstlnk_18
		dw lstlnk_19
		dw lstlnk_1A
		dw lstlnk_1B
VDOSL:		dw VROOTL

;------------------------------------------------------------------------------
; BDOS
;------------------------------------------------------------------------------

		voc DOS
		header	BDOS, "BDOS"

		pop	hl
		pop	de
		push	bc
		push	iy
		ld	c, l
		call	5
		ld	l, a
		ld	h, 0
		pop	iy
		pop	bc
		push	hl
		jp	NEXT

;------------------------------------------------------------------------------
; 2A CONSTANT B/FCB
;------------------------------------------------------------------------------

		header	BFCB, "B/FCB", DOCON

		dw 2Ah

;------------------------------------------------------------------------------
; SET-DMA
; : SET-DMA   1A BDOS DROP ;
;------------------------------------------------------------------------------

		header	SETDMA, "SET-DMA", DOCOL

		dw XLIT
		dw 1Ah
		dw BDOS
		dw DROP
		dw UNNEST

;------------------------------------------------------------------------------
; DOS-ERR?
; : DOS-ERR?   0FF = ;
;------------------------------------------------------------------------------

		header	DOSERR, "DOS-ERR?", DOCOL

		dw XLIT
		dw 0FFh
		dw EQUAL
		dw UNNEST

;------------------------------------------------------------------------------
; CREATE FCB2
; B/FCB ALLOT
;------------------------------------------------------------------------------

		header	FCB2, "FCB2", DOVAR

		db    0
		db  41h	; A
		db  49h	; I
		db  47h	; G
		db  56h	; V
		db  31h	; 1
		db  33h	; 3
		db  20h
		db  20h
		db  43h	; C
		db  4Fh	; O
		db  4Dh	; M
		db    0
		db    0
		db    0
		db  4Dh	; M
		db  7Dh	; }
		db  7Eh	; ~
		db  7Fh	; 
		db  80h	; 
		db  8Dh	; 
		db    0
		db    0
		db    0
		db    0
		db    0
		db    0
		db    0
		db    0
		db    0
		db    0
		db    0
		db  4Dh	; M
		db    0
		db    0
		db    0
		db    0
		db    0
		db    0
		db    0
		db    0
		db    0

;------------------------------------------------------------------------------
; RESET
; : RESET   0 0D BDOS DROP ;
;------------------------------------------------------------------------------

		header	RESET, "RESET", DOCOL

		dw ZERO
		dw XLIT
		dw 0Dh
		dw BDOS
		dw DROP
		dw UNNEST

;------------------------------------------------------------------------------
; CLOSE
; : CLOSE   10 BDOS DOS-ERR? ABORT" Close error" ;
;------------------------------------------------------------------------------

		header	CLOSE, "CLOSE", DOCOL

		dw XLIT
		dw 10h
		dw BDOS
		dw DOSERR
		dw XABORT
		db 11,"Close error"
		dw UNNEST

;------------------------------------------------------------------------------
; SEARCH0
; : SEARCH0   11 BDOS ;
;------------------------------------------------------------------------------

		header	SEARCHZ, "SEARCH0", DOCOL

		dw XLIT
		dw 11h
		dw BDOS
		dw UNNEST

;------------------------------------------------------------------------------
; SEARCH
; : SEARCH   12 BDOS ;
;------------------------------------------------------------------------------

		header	SEARCH, "SEARCH", DOCOL

		dw XLIT
		dw 12h
		dw BDOS
		dw UNNEST

;------------------------------------------------------------------------------
; DELETE
; : DELETE   13 BDOS ;
;------------------------------------------------------------------------------

		header	DELETE, "DELETE", DOCOL

		dw XLIT
		dw 13h
		dw BDOS
		dw UNNEST

;------------------------------------------------------------------------------
; READ
; : READ   14 BDOS DOS-ERR? ABORT" Read error" ;
; ' READ IS READ-BLOCK
;------------------------------------------------------------------------------

		header	READ1, "READ", DOCOL

		dw XLIT
		dw 14h
		dw BDOS
		dw DOSERR
		dw XABORT
		db 10,"Read error"
		dw UNNEST

;------------------------------------------------------------------------------
; WRITE
; : WRITE   15 BDOS DOS-ERR? ABORT" Write error" ;
; ' WRITE IS WRITE-BLOCK
;------------------------------------------------------------------------------

		header	WRITE1, "WRITE", DOCOL

		dw XLIT
		dw 15h
		dw BDOS
		dw DOSERR
		dw XABORT
		db 11,"Write error"
		dw UNNEST

;------------------------------------------------------------------------------
; MAKE-FILE
; : MAKE-FILE   16 BDOS DOS-ERR? ABORT" Can't MAKE File " ;
;------------------------------------------------------------------------------

		header	MAKFILE, "MAKE-FILE", DOCOL

		dw XLIT
		dw 16h
		dw BDOS
		dw DOSERR
		dw XABORT
		db 16,"Can",27h,"t MAKE File "
		dw UNNEST

;------------------------------------------------------------------------------
; OPEN
; : OPEN    0F BDOS DOS-ERR? ABORT" Open error " ;
;------------------------------------------------------------------------------

		header	OPEN, "OPEN", DOCOL

		dw XLIT
		dw 0Fh
		dw BDOS
		dw DOSERR
		dw XABORT
		db 11,"Open error "
		dw UNNEST

;------------------------------------------------------------------------------
; (!FCB)
; : (!FCB)   DUP B/FCB ERASE DUP 1+  0B BLANK >R OVER 1+ C@ ASCII : = 
;    IF OVER C@ 40 - R@ C! 2 /STRING THEN R> 1+ -ROT 0 DO DUP C@ ASCII . = 
;    IF SWAP 8 I - + ELSE 2DUP C@ SWAP C! SWAP 1+ THEN SWAP 1+ LOOP 2DROP ;
;------------------------------------------------------------------------------

		header	XSTFCB, "(!FCB)", DOCOL

		dw DUPP
		dw BFCB
		dw ERASE
		dw DUPP
		dw ONEP
		dw XLIT
		dw 0Bh
		dw BLANK
		dw TOR
		dw OVER
		dw ONEP
		dw CAT
		dw XLIT
		dw 3Ah		; ':'
		dw EQUAL
		dw QBRANCH	; if
		dw off_291D
		dw OVER
		dw CAT
		dw XLIT
		dw 40h
		dw MINUS
		dw RAT
		dw CSTORE
		dw TWO
		dw SSTRING
off_291D:	dw FROMR	; then
		dw ONEP
		dw MROT
		dw ZERO
		dw XDO
		dw off_295B
off_2929:	dw DUPP
		dw CAT
		dw XLIT
		dw 2Eh		; '.'
		dw EQUAL
		dw QBRANCH	; if
		dw off_2947	
		dw SWAP
		dw XLIT
		dw 8
		dw IDO
		dw MINUS
		dw PLUS
		dw BRANCH
		dw off_2953
off_2947:	dw TDUPP	; else
		dw CAT
		dw SWAP
		dw CSTORE
		dw SWAP
		dw ONEP
off_2953:	dw SWAP		; then
		dw ONEP
		dw XLOOP
		dw off_2929
off_295B:	dw TDROP
		dw UNNEST

;------------------------------------------------------------------------------
; !FCB
; : !FCB   BL WORD COUNT ROT (!FCB) ;
;------------------------------------------------------------------------------

		header	STFCB, "!FCB", DOCOL

		dw BL
		dw WORD
		dw COUNT
		dw ROT
		dw XSTFCB
		dw UNNEST

;------------------------------------------------------------------------------
; SAVE
; : SAVE  FCB2 DUP !FCB DUP DELETE DROP DUP MAKE-FILE -ROT OVER + SWAP 
;    ?DO I SET-DMA DUP WRITE 80 +LOOP CLOSE ;
;------------------------------------------------------------------------------

		header	SAVE, "SAVE", DOCOL

		dw FCB2
		dw DUPP
		dw STFCB
		dw DUPP
		dw DELETE
		dw DROP
		dw DUPP
		dw MAKFILE
		dw MROT
		dw OVER
		dw PLUS
		dw SWAP
		dw XQDO
		dw off_29A9
off_2999:	dw IDO
		dw SETDMA
		dw DUPP
		dw WRITE1
		dw XLIT
		dw 80h
		dw XPLOOP
		dw off_2999
off_29A9:	dw CLOSE
		dw UNNEST

;------------------------------------------------------------------------------
; FREAD
; : FREAD   FCB2 DUP !FCB DUP OPEN SWAP 
;    BEGIN DUP SET-DMA OVER 14 BDOS 0= WHILE 80 + REPEAT DROP CLOSE ;
;------------------------------------------------------------------------------

		header	FREAD, "FREAD", DOCOL

		dw FCB2
		dw DUPP
		dw STFCB
		dw DUPP
		dw OPEN
		dw SWAP
off_29C3:	dw DUPP
		dw SETDMA
		dw OVER
		dw XLIT
		dw 14h
		dw BDOS
		dw ZEQU
		dw QBRANCH
		dw off_29DF
		dw XLIT
		dw 80h
		dw PLUS
		dw BRANCH
		dw off_29C3
off_29DF:	dw DROP
		dw CLOSE
		dw UNNEST

;------------------------------------------------------------------------------
; (PUT)
; : (PUT)   SOD @ EOD @ OVER - SAVE ;
; ' (PUT) IS PUT
;------------------------------------------------------------------------------

		voc	IO
		header	XPUT, "(PUT)", DOCOL

		dw SOD
		dw AT
		dw EOD
		dw AT
		dw OVER
		dw MINUS
		dw SAVE
		dw UNNEST

;------------------------------------------------------------------------------
; (GET)
; : (GET)   SOD @ FREAD ;
; ' (GET) IS GET
;------------------------------------------------------------------------------

		header	XGET, "(GET)", DOCOL

		dw SOD
		dw AT
		dw FREAD
		dw UNNEST

;------------------------------------------------------------------------------
; DELETE-FILE
; : DELETE-FILE   FCB2 DUP !FCB DELETE DOS-ERR? ABORT" not found " ;
;------------------------------------------------------------------------------

		voc FORTH
		header	DELFILE, "DELETE-FILE", DOCOL

		dw FCB2
		dw DUPP
		dw STFCB
		dw DELETE
		dw DOSERR
		dw XABORT
aNotFound:	db 10,"not found "
		dw UNNEST

;------------------------------------------------------------------------------
; .NAME
; : .NAME   #OUT @ C/L > IF CR THEN 20 * PAD + 1+ 8 
;    2DUP TYPE SPACE + 3 TYPE 3 SPACES ;
;------------------------------------------------------------------------------

		header	DNAME, ".NAME", DOCOL

		dw NOUT
		dw AT
		dw CPERL
		dw GREAT
		dw QBRANCH
		dw off_2A52
		dw CR
off_2A52:	dw XLIT
		dw 20h
		dw STAR
		dw PAD
		dw PLUS
		dw ONEP
		dw XLIT
		dw 8
		dw TDUPP
		dw TYPE
		dw SPACE
		dw PLUS
		dw THREE
		dw TYPE
		dw THREE
		dw SPACES
		dw UNNEST

;------------------------------------------------------------------------------
; DIR
; : DIR   " ????????.???" FCB2 (!FCB) CR PAD SET-DMA FCB2 SEARCH0 
;    BEGIN .NAME FCB2 SEARCH DUP DOS-ERR? UNTIL DROP ;
;------------------------------------------------------------------------------

		header	DIR, "DIR", DOCOL

		dw XQUOTE
		db 12,"????????.???"
		dw FCB2
		dw XSTFCB
		dw CR
		dw PAD
		dw SETDMA
		dw FCB2
		dw SEARCHZ
off_2A99:	dw DNAME
		dw FCB2
		dw SEARCH
		dw DUPP
		dw DOSERR
		dw QBRANCH
		dw off_2A99
		dw DROP
		dw UNNEST

;------------------------------------------------------------------------------
; SAVE-SYSTEM
; : SAVE-SYSTEM   100 HERE SAVE ;
;------------------------------------------------------------------------------

		voc FORTH
		header	SAVSYST, "SAVE-SYSTEM", DOCOL

		dw XLIT
		dw ORIGIN
		dw HERE
		dw SAVE
		dw UNNEST

;------------------------------------------------------------------------------
; START
; : START   SOD @ ;
;------------------------------------------------------------------------------

		voc IO
		header	START, "START", DOCOL

		dw SOD
		dw AT
		dw UNNEST

;------------------------------------------------------------------------------
; END
; VARIABLE END   0 END !
;------------------------------------------------------------------------------

		header	END, "END", DOVAR

ENDV:		dw 0

;------------------------------------------------------------------------------
; TOP
; : TOP   EOD @ ;
;------------------------------------------------------------------------------

		header	TOP, "TOP", DOCOL

		dw EOD
		dw AT
		dw UNNEST

;------------------------------------------------------------------------------
; CLEAR>END
; : CLEAR>END   END @ TOP OVER - ERASE ;
;------------------------------------------------------------------------------

		header	CLTOEND, "CLEAR>END", DOCOL

		dw END
		dw AT
		dw TOP
		dw OVER
		dw MINUS
		dw ERASE
		dw UNNEST

;------------------------------------------------------------------------------
; INIT
; : INIT   START END ! CLEAR>END ;
;------------------------------------------------------------------------------
		
		voc FORTH
		header	INIT, "INIT", DOCOL

		dw START
		dw END
		dw STORE
		dw CLTOEND
		dw UNNEST

;------------------------------------------------------------------------------
;  FREE
; : FREE   TOP END @ - ." are " DECIMAL . ." Bytes. " ;
;------------------------------------------------------------------------------

		header	FREE, "FREE", DOCOL

		dw TOP
		dw END
		dw AT
		dw MINUS
		dw XDOTQ
		db 4,"are "
		dw DECIMAL
		dw DOT
		dw XDOTQ
		db 7,"Bytes. "
		dw UNNEST

;------------------------------------------------------------------------------
; SUCHE
;------------------------------------------------------------------------------

		voc IO
		header	SUCHE, "SUCHE"

		exx
		and	a
		ld	hl, (ENDV)
		ld	de, (INIT_SOD)
		sbc	hl, de
		ex	de, hl
		ld	b, d
		ld	c, e
		inc	bc
		pop	de
loc_2B5E:	xor	a
		cpir
		jp	pe, loc_2B6A
		ld	hl, 0
		xor	a
		jr	loc_2B6C
loc_2B6A:	ld	a, (hl)
		cp	e
loc_2B6C:	jp	nz, loc_2B5E
		push	hl
		exx
		jp	NEXT

;------------------------------------------------------------------------------
; SUCH0
;------------------------------------------------------------------------------

		header	SUCHZ, "SUCH0"

		exx
		pop	hl
		ld	bc, 0
		xor	a
		cpir
		push	hl
		exx
		jp	NEXT

;------------------------------------------------------------------------------
; LABEL STORE
;------------------------------------------------------------------------------

		header	STORE1, "STORE", DOVAR

sub_2B95:	push	af
		dec	bc
		ld	a, b
		and	c
		inc	a
		jr	z, loc_2BA0
		pop	af
		ld	(hl), a
		inc	hl
		ret
loc_2BA0:	pop	af
		pop	hl
		ld	hl, 0
		push	hl
		exx
		jp	NEXT

;------------------------------------------------------------------------------
; COMPRESS
;------------------------------------------------------------------------------

		header	COMPRESS, "COMPRESS"

		ld	hl, 400h
		exx
		pop	bc
		pop	hl
		pop	de
		xor	a
		ex	af, af'
loc_2BC0:	ld	a, (de)
		inc	de
		cp	' '
		jp	z, loc_2BD9
		ex	af, af'
		and	a
		jr	z, loc_2BD2
		dec	a
		or	80h 
		call	sub_2B95	; STORE1
		xor	a
loc_2BD2:	ex	af, af'
		call	sub_2B95	; STORE1
		jp	loc_2BE5
loc_2BD9:	ex	af, af'
		cp	7Fh 
		jr	nz, loc_2BE3
		or	80h 
		call	sub_2B95	; STORE1
loc_2BE3:	inc	a
		ex	af, af'
loc_2BE5:	exx
		dec	hl
		ld	a, h
		or	l
		exx
		jp	nz, loc_2BC0
		ex	af, af'
		and	a
		jr	z, loc_2BF7
		dec	a
		or	80h 
		call	sub_2B95	; STORE1
loc_2BF7:	push	hl
		exx
		jp	NEXT

;------------------------------------------------------------------------------
; DECOMPRESS
;------------------------------------------------------------------------------

		header	DECOMPRS, "DECOMPRESS"

		exx
		pop	hl
		pop	de
loc_2C0E:	ld	a, (de)
		inc	de
		and	a
		jr	z, loc_2C27
		cp	80h 
		jr	c, loc_2C23
		and	7Fh 
		jr	z, loc_2C21
loc_2C1B:	ld	(hl), ' '
		inc	hl
		dec	a
		jr	nz, loc_2C1B
loc_2C21:	ld	a, ' '
loc_2C23:	ld	(hl), a
		inc	hl
		jr	loc_2C0E
loc_2C27:	exx
		jp	NEXT

;------------------------------------------------------------------------------
; CREAD
; : CREAD   SUCHE ?DUP IF 1+ SWAP DECOMPRESS ELSE B/BUF BLANK THEN ;
;------------------------------------------------------------------------------

		header	CREAD, "CREAD", DOCOL

		dw SUCHE
		dw QDUPP
		dw QBRANCH
		dw off_2C47
		dw ONEP
		dw SWAP
		dw DECOMPRS
		dw BRANCH
		dw off_2C4B
off_2C47:	dw BBUF
		dw BLANK
off_2C4B:	dw UNNEST

;------------------------------------------------------------------------------
; CWRITE
; : CWRITE   >R R@ SUCHE ?DUP IF DUP SUCH0 2DUP - THEN END +! 
;    TUCK TOP SWAP - CMOVE END @ R> OVER 1+ C! 2+ TOP OVER - COMPRESS DUP 
;    IF DUP END @ - 0A > IF DUP END ! THEN THEN CLEAR>END 0= 
;    ABORT" not enough memory" ;
;------------------------------------------------------------------------------

		header	CWRITE, "CWRITE", DOCOL

		dw TOR
		dw RAT
		dw SUCHE
		dw QDUPP
		dw QBRANCH
		dw off_2C7A
		dw DUPP
		dw SUCHZ
		dw TDUPP
		dw MINUS
		dw END
		dw PLUSSTORE
		dw TUCK
		dw TOP
		dw SWAP
		dw MINUS
		dw CMOVE
off_2C7A:	dw END
		dw AT
		dw FROMR
		dw OVER
		dw ONEP
		dw CSTORE
		dw TWOP
		dw TOP
		dw OVER
		dw MINUS
		dw COMPRESS
		dw DUPP
		dw QBRANCH
		dw off_2CAE
		dw DUPP
		dw END
		dw AT
		dw MINUS
		dw XLIT
		dw 0Ah
		dw GREAT
		dw QBRANCH
		dw off_2CAE
		dw DUPP
		dw END
		dw STORE
off_2CAE:	dw CLTOEND
		dw ZEQU
		dw XABORT
		db 17,"not enough memory"
		dw UNNEST

;------------------------------------------------------------------------------
; ADJUST
; : ADJUST   TOP 1- BEGIN DUP C@ UNTIL 1+ END ! ;
;------------------------------------------------------------------------------

		header	ADJUST, "ADJUST", DOCOL

		dw TOP
off_2CD5:	dw ONEM
		dw DUPP
		dw CAT
		dw QBRANCH
		dw off_2CD5
		dw ONEP
		dw END
		dw STORE
		dw UNNEST

;------------------------------------------------------------------------------
; CGET
; : CGET   (GET) ADJUST EMPTY-BUFFERS ;
;------------------------------------------------------------------------------

		header	CGET, "CGET", DOCOL

		dw XGET
		dw ADJUST
		dw EMPTYBUF
		dw UNNEST

;------------------------------------------------------------------------------
; NORMAL
; : NORMAL ['] READ IS READ-BLOCK ['] WRITE IS WRITE-BLOCK ['] (GET) IS GET ;
;------------------------------------------------------------------------------

		voc FORTH
		header	NORMAL, "NORMAL", DOCOL

		dw XLIT
		dw READ
		dw XIS
		dw READBLK
		dw XLIT
		dw WRITE
		dw XIS
		dw WRITEBLK
		dw XLIT
		dw XGET
		dw XIS
		dw GET
		dw UNNEST

;------------------------------------------------------------------------------
; COMPRESSED
; : COMPRESSED ['] CREAD IS READ-BLOCK ['] CWRITE IS WRITE-BLOCK ['] CGET IS GET ;
;------------------------------------------------------------------------------

		header	COMPRESSED, "COMPRESSED", DOCOL

		dw XLIT
		dw CREAD
		dw XIS
		dw READBLK
		dw XLIT
		dw CWRITE
		dw XIS
		dw WRITEBLK
		dw XLIT
		dw CGET
		dw XIS
		dw GET
		dw UNNEST

;------------------------------------------------------------------------------
; MARK EMPTY
;------------------------------------------------------------------------------

		header	EMPTY, "EMPTY", DOMARK


	if 1=0

	; der Decompiler kann mit 
	;   GET SEE
	;   1 LOAD
	; nachgeladen werden

;------------------------------------------------------------------------------
; VOCABULARY DECOMPILER
;------------------------------------------------------------------------------

		dw off_2A74
		db  8Ah	; 
		db  44h	; D
		db  45h	; E
		db  43h	; C
		db  4Fh	; O
		db  4Dh	; M
		db  50h	; P
		db  49h	; I
		db  4Ch	; L
		db  45h	; E
		db 0D2h	; 
		dw DOVOC
		dw off_319D
		dw off_2E0F
		dw off_3182
		dw off_316B
		dw off_2756

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

off_2D69:	dw off_2D46
		db  83h	; 
		db  4Dh	; M
		db  41h	; A
		db 0D0h	; 
off_2D6F:	dw DOCOL
		dw TDUPP
		dw AT
		dw ULESS
		dw NOTT
		dw XABORT
		db 3,"Out"
		dw TWOP
		dw SWAP
		dw TTIMES
		dw PLUS
		dw UNNEST

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

off_2D89:	dw off_2D1D
		db  85h	; 
		db  43h	; C
		db  41h	; A
		db  53h	; S
		db  45h	; E
		db 0BAh	; 
		dw DOCOL
		dw CREATE
		dw COMMA
		dw STCSP
		dw HIDE
		dw RBRACKET
		dw XSCODE
CASE:		call	DODOE
		dw off_2D6F
		dw AT
		dw EXECUTE
		dw UNNEST

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

		dw off_2D69
		db  8Ch	; 
		db  41h	; A
		db  53h	; S
		db  53h	; S
		db  4Fh	; O
		db  43h	; C
		db  49h	; I
		db  41h	; A
		db  54h	; T
		db  49h	; I
		db  56h	; V
		db  45h	; E
		db 0BAh	; 
		dw DOCOL
		dw CREATE
		dw COMMA
		dw XSCODE
ASSOC:		call	DODOE
		dw DUPP
		dw AT
		dw MROT
		dw DUPP
		dw AT
		dw ZERO
		dw XDO
		dw off_2DF0
off_2DD4:	dw TWOP
		dw TDUPP
		dw AT
		dw EQUAL
		dw QBRANCH
		dw off_2DEC
		dw TDROP
		dw DROP
		dw IDO
		dw DUPP
		dw DUPP
		dw XLEAVE
off_2DEC:	dw XLOOP
		dw off_2DD4
off_2DF0:	dw TDROP
		dw UNNEST

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

		dw off_2CF8
		db  82h	; 
		db  2Eh	; .
		db 0B4h	; 
off_2DF9:	dw DOCOL
		dw ZERO
		dw BDIGS
		dw DIG
		dw DIG
		dw DIG
		dw DIG
		dw EDIGS
		dw TYPE
		dw SPACE
		dw UNNEST

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

off_2E0F:	dw 0
		db  83h	; 
		db  49h	; I
		db  53h	; S
		db 0D4h	; 
		dw DOCOL
		dw TICK
		dw COMMA
		dw UNNEST

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

off_2E1D:	dw 0
		db  83h	; 
		db  54h	; T
		db  59h	; Y
		db 0D0h	; 
		dw DOCOL
		dw TICK
		dw AT
		dw COMMA
		dw UNNEST

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

off_2E2D:	dw 0
		db  85h	; 
		db  3Fh	; ?
		db  53h	; S
		db  54h	; T
		db  4Fh	; O
		db 0D0h	; 
off_2E35:	dw DOCOL
		dw KEYQ
		dw DUPP
		dw QBRANCH
		dw off_2E4B
		dw KEY
		dw TDROP
		dw KEY
		dw XLIT
		dw 1Bh
		dw EQUAL
off_2E4B:	dw UNNEST
off_2E4D:	dw 0
		db  85h	; 
		db  2Eh	; .
		db  57h	; W
		db  4Fh	; O
		db  52h	; R
		db 0C4h	; 
off_2E55:	dw DOCOL
		dw DUPP
		dw AT
		dw TONAME
		dw DOTID
		dw TWOP
		dw UNNEST

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

off_2E63:	dw off_2E4D
		db  87h	; 
		db  2Eh	; .
		db  49h	; I
		db  4Eh	; N
		db  4Ch	; L
		db  49h	; I
		db  4Eh	; N
		db 0C5h	; 
off_2E6D:	dw DOCOL
		dw off_2E55
		dw DUPP
		dw AT
		dw DUPP
		dw DOT
		dw ZLESS
		dw QBRANCH
		dw off_2E8E
		dw DUPP
		dw AT
		dw XDOTQ
asc_2E85:	db 2,"( "
off_2E88:	dw UDOT
		dw XDOTQ
		db 1,')'
off_2E8E:	dw TWOP
		dw UNNEST

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

off_2E92:	dw off_2E63
		db  87h	; 
		db  2Eh	; .
		db  42h	; B
		db  52h	; R
		db  41h	; A
		db  4Eh	; N
		db  43h	; C
		db 0C8h	; 
off_2E9C:	dw DOCOL
		dw off_2E55
		dw DUPP
		dw AT
		dw off_2DF9
		dw TWOP
		dw UNNEST

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

off_2EAA:	dw off_2E92
		db  86h	; 
		db  2Eh	; .
		db  51h	; Q
		db  55h	; U
		db  4Fh	; O
		db  54h	; T
		db 0C5h	; 
off_2EB3:	dw DOCOL
		dw off_2E55
		dw off_2E55
		dw UNNEST

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

off_2EBB:	dw off_2EAA
		db  87h	; 
		db  2Eh	; .
		db  53h	; S
		db  54h	; T
		db  52h	; R
		db  49h	; I
		db  4Eh	; N
		db 0C7h	; 
off_2EC5:	dw DOCOL
		dw off_2E55
		dw COUNT
		dw TDUPP
		dw TYPE
		dw XLIT
		dw 22h
		dw EMIT
		dw PLUS
		dw UNNEST

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

off_2ED9:	dw off_2EBB
		db  86h	; 
		db  2Eh	; .
		db  53h	; S
		db  45h	; E
		db  4Dh	; M
		db  49h	; I
		db 0D3h	; 
off_2EE2:	dw DOCOL
		dw XDOTQ
		db 1,';'
		dw DROP
		dw ZERO
		dw UNNEST

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

off_2EEE:	dw off_2ED9
		db  86h	; 
		db  2Eh	; .
		db  3Bh	; ;
		db  55h	; U
		db  53h	; S
		db  45h	; E
		db 0D3h	; 
off_2EF7:	dw DOCOL
		dw off_2E55
		dw DROP
		dw ZERO
off_2EFF:	dw UNNEST

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

off_2F01:	dw off_2EEE
		db  84h	; 
		db  2Eh	; .
		db  50h	; P
		db  46h	; F
		db 0C1h	; 
off_2F08:	dw DOVEC
		dw off_2FB8

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

off_2F0C:	dw off_2F01
		db  86h	; 
		db  2Eh	; .
		db  44h	; D
		db  4Fh	; O
		db  45h	; E
		db  53h	; S
		db 0BEh	; 
off_2F15:	dw DOCOL
		dw XDOTQ
		db 5,"DOES>"
		dw ONEP
		dw off_2F08
		dw UNNEST

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

off_2F25:	dw off_2F0C
		db  86h	; 
		db  2Eh	; .
		db  3Bh	; ;
		db  43h	; C
		db  4Fh	; O
		db  44h	; D
		db 0C5h	; 
off_2F2E:	dw DOCOL
		dw off_2E55
		dw DUPP
		dw CAT
		dw XLIT
		dw 0CDh
		dw EQUAL
		dw OVER
		dw ONEP
		dw AT
		dw TODOES
		dw EQUAL
		dw ANDD
		dw QBRANCH
		dw off_2F50
		dw off_2F15
		dw ZERO
off_2F50:	dw DROP
		dw ZERO
off_2F54:	dw UNNEST
off_2F56:	dw off_2E2D
		db  88h	; 
		db  3Fh	; ?
		db  53h	; S
		db  50h	; P
		db  45h	; E
		db  43h	; C
		db  49h	; I
		db  41h	; A
		db 0CCh	; 
off_2F61:	dw ASSOC
		db  0Eh
		db    0
		dw XLIT
		dw BRANCH
		dw QBRANCH
		dw XDO
		dw XQDO
		dw XLOOP
		dw XPLOOP
		dw COMPILE
		dw XDOTQ
		dw XQUOTE
		dw XABORT
		dw XSCODE
		dw UNNEST

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

		dw XSUSES
off_2F81:	dw off_2F56
		db  87h	; 
		db  53h	; S
		db  50h	; P
		db  45h	; E
		db  43h	; C
		db  49h	; I
		db  41h	; A
		db 0CCh	; 
off_2F8B:	dw CASE
		dw 0Fh
		dw off_2E6D
		dw off_2E9C
		dw off_2E9C
		dw off_2E9C
		dw off_2E9C
		dw off_2E9C
		dw off_2E9C
		dw off_2EB3
		dw off_2EC5
		dw off_2EC5
		dw off_2EC5
		dw off_2F2E
		dw off_2EE2
		dw off_2EF7
		dw off_2E55
		dw UNNEST

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

off_2FAF:	dw off_2E1D
		db  86h	; 
		db  28h	; (
		db  2Eh	; .
		db  50h	; P
		db  46h	; F
		db  41h	; A
		db 0A9h	; 
off_2FB8:	dw DOCOL
		dw TOBODY
off_2FBC:	dw CR
		dw DUPP
		dw off_2DF9
		dw THREE
		dw SPACES
		dw DUPP
		dw AT
		dw off_2F61
		dw off_2F8B
		dw DUPP
		dw ZEQU
		dw off_2E35
		dw ORR
off_2FD6:	dw QBRANCH
		dw off_2FBC
		dw DROP
		dw UNNEST

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

off_2FDE:	dw off_2F25
		db  8Ah	; 
		db  2Eh	; .
		db  49h	; I
		db  4Dh	; M
		db  4Dh	; M
		db  45h	; E
		db  44h	; D
		db  49h	; I
		db  41h	; A
		db  54h	; T
		db 0C5h	; 
off_2FEB:	dw DOCOL
		dw TONAME
		dw CAT
		dw XLIT
		dw 40h
		dw ANDD
		dw QBRANCH
		dw off_3008
		dw XDOTQ
		db 10," IMMEDIATE"
off_3008:	dw UNNEST
off_300A:	dw off_2FDE
		db  89h	; 
		db  2Eh	; .
		db  43h	; C
		db  4Fh	; O
		db  4Eh	; N
		db  53h	; S
		db  54h	; T
		db  41h	; A
		db  4Eh	; N
		db 0D4h	; 
off_3016:	dw DOCOL
		dw DUPP
		dw TWOP
		dw QUEST
		dw XDOTQ
		db 9,"CONSTANT "
		dw TONAME
		dw DOTID
		dw UNNEST

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

off_3030:	dw off_300A
		db  89h	; 
		db  2Eh	; .
		db  56h	; V
		db  41h	; A
		db  52h	; R
		db  49h	; I
		db  41h	; A
		db  42h	; B
		db  4Ch	; L
		db 0C5h	; 
off_303C:	dw DOCOL
		dw DUPP
		dw TWOP
		dw off_2DF9
		dw XDOTQ
		db 9,"VARIABLE "
		dw DUPP
		dw TONAME
off_3054:	dw DOTID
		dw XDOTQ
		db 7,"Wert = "
		dw TWOP
		dw QUEST
		dw UNNEST

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

off_3066:	dw off_3030
		db  82h	; 
		db  2Eh	; .
		db 0BAh	; 
off_306B:	dw DOCOL
		dw XDOTQ
		db 2,": "
		dw DUPP
		dw TONAME
		dw DOTID
		dw off_2F08
		dw UNNEST

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

off_307C:	dw off_3066
		db  85h	; 
		db  2Eh	; .
		db  55h	; U
		db  53h	; S
		db  45h	; E
		db 0D2h	; 
off_3084:	dw DOCOL
		dw DUPP
		dw TWOP
		dw QUEST
		dw XDOTQ
asc_308E:	db 14,"USER VARIABLE "
		dw DUPP
		dw TONAME
		dw DOTID
		dw XDOTQ
		db 7,"Wert = "
		dw TOIS
		dw QUEST
		dw UNNEST

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

off_30B3:	dw off_2FAF
		db  85h	; 
		db  28h	; (
		db  53h	; S
		db  45h	; E
		db  45h	; E
		db 0A9h	; 
off_30BB:	dw DOVEC
		dw off_31A7

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

off_30BF:	dw off_307C
		db  86h	; 
		db  2Eh	; .
		db  44h	; D
		db  45h	; E
		db  46h	; F
		db  45h	; E
		db 0D2h	; 
off_30C8:	dw DOCOL
		dw XDOTQ
		db 9,"DEFERRED "
		dw DUPP
		dw TONAME
		dw DOTID
		dw XDOTQ
		db 2,"IS"
		dw TOIS
		dw AT
		dw off_30BB
		dw UNNEST

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

off_30E9:	dw off_30BF
		db  87h	; 
		db  2Eh	; .
		db  55h	; U
		db  44h	; D
		db  45h	; E
		db  46h	; F
		db  45h	; E
		db 0D2h	; 
off_30F3:	dw DOCOL
		dw XDOTQ
		db 14,"USER DEFERRED "
		dw DUPP
		dw TONAME
		dw DOTID
		dw XDOTQ
		db 2,"IS"
		dw TOIS
		dw AT
		dw off_30BB
		dw UNNEST

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

off_3119:	dw off_30E9
		db  86h	; 
		db  2Eh	; .
		db  4Fh	; O
		db  54h	; T
		db  48h	; H
		db  45h	; E
		db 0D2h	; 
off_3122:	dw DOCOL
		dw DUPP
		dw TONAME
		dw DOTID
		dw DUPP
		dw AT
		dw ONEP
		dw AT
		dw TODOES
		dw EQUAL
		dw QBRANCH
		dw off_3142
		dw AT
		dw off_2F15
		dw BRANCH
		dw off_3169
off_3142:	dw DUPP
		dw AT
		dw TWOM
		dw EQUAL
		dw XDOTQ
		db 3,"is "
		dw QBRANCH
		dw off_315F
		dw XDOTQ
		db 4,"code"
		dw BRANCH
		dw off_3169
off_315F:	dw XDOTQ
		db 7,"unknown"
off_3169:	dw UNNEST

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

off_316B:	dw off_2F81
		db  84h	; 
		db  3Fh	; ?
		db  54h	; T
		db  59h	; Y
		db 0D0h	; 
off_3172:	dw ASSOC
		dw 6
		dw DOCOL
		dw DOCON
off_317A:	dw DOVAR
		dw DOUSE
		dw DOVEC
		dw DOUVEC

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

off_3182:	dw off_3119
		db  84h	; 
		db  2Eh	; .
		db  54h	; T
		db  59h	; Y
		db 0D0h	; 
off_3189:	dw CASE
		dw 7
		dw off_306B
		dw off_3016
		dw off_303C
		dw off_3084
		dw off_30C8
		dw off_30F3
		dw off_3122
		dw UNNEST

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

off_319D:	dw off_30B3
		db  87h	; 
		db  28h	; (
		db  28h	; (
		db  53h	; S
		db  45h	; E
		db  45h	; E
		db  29h	; )
		db 0A9h	; 
off_31A7:	dw DOCOL
		dw CR
		dw BASE
		dw AT
		dw SWAP
		dw HEX
		dw DUPP
		dw DUPP
		dw AT
		dw off_3172
		dw off_3189
		dw off_2FEB
		dw BASE
		dw STORE
		dw UNNEST

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

		dw off_2D89
		db  83h	; 
		db  53h	; S
		db  45h	; E
		db 0C5h	; 
		dw DOCOL
		dw TICK
		dw off_30BB
		dw UNNEST

	endif